/***************************************************************************
 *   Copyright (C) 2007 by Veselin Georgiev                                *
 *   anrieff@mgail.com (convert to GMail)                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

struct EmbeddedBitmap {
	char *name;
	unsigned char *data;
	int size;
};

class InputStream;
class Bitmap {
	int x, y;
	unsigned *d;
	bool _loadimp(InputStream *stream);
public:
	Bitmap();
	Bitmap(int x, int y);
	~Bitmap();
	int width() const;
	int height() const;
	unsigned* data() const;
	void clear(void);
	bool load_from_file(const char * filename);
	bool load_embedded(const char * embedded_bitmap_name);
	bool save_to_file(const char * filename);
	void rescale(int new_width, int new_height);
	unsigned sample_bilinear(float fx, float fy);
	unsigned sample(int ix, int iy);
};
