/***************************************************************************
 *   Copyright (C) 2007 by Veselin Georgiev                                *
 *   anrieff@mgail.com (convert to GMail)                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <string.h>
#include "config.h"
#include "display.h"
#include "intro.h"
#include "game.h"
#include "board.h"

bool app_init(void)
{
	config.init();
	if (!display.init()) {
		return false;
	}
	intro();
	prepare_texture();
	game_preinit();
	return true;
}

void app_close(void)
{
	display.close();
	config.close();
}

int main(int argc, char *argv[])
{
	if (!app_init()) return -1;
	if (command_args_allow_playing_the_game(argc, argv)) {
		while (1) {
			if (!select_players()) break;
			if (!play_game()) break;
		}
	}
	
	app_close();
	return 0;
}
