/***************************************************************************
 *   Copyright (C) 2007 by Veselin Georgiev                                *
 *   anrieff@mgail.com (convert to GMail)                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __PAWN_H__
#define __PAWN_H__

#include "render.h"

class Pawn : public Object {
	unsigned color;
	Vector pos;
	Vector movement;
	Matrix uvw, iuvw;
	double skew_amount;
	double radius;
	int id;
public:
	Pawn(Vector where, unsigned color, int id, double radius = 0.4)
	{
		pos = where; this->color = color;
		this->radius = radius;
		this->id = id;
		movement.zero();
		skew_amount = 0;
	}
	double intersect(const Ray & ray, IContext &ctx);
	unsigned shade(const Ray & ray, IContext &ctx, const Light & light);
	BBox get_bbox(void);
	int get_id(void);
	void move(Vector start_pos, Vector new_pos, double x);
	~Pawn();
};


void test_splines(void);

#endif // __pawn_H__
