/***************************************************************************
 *   Copyright (C) 2007 by Veselin Georgiev                                *
 *   anrieff@mgail.com (convert to GMail)                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdlib.h>
#include <time.h>
#include "utils.h"

char static_sort_storage[SSSTORAGE_SIZE];

void Random::seed(unsigned seed)
{
	srand(seed);
}

Random::Random()
{
	seed(time(NULL));
}

int Random::next(void)
{
	return (rand() % 32609) % 6 + 1;
}

double Random::drand(void)
{
	return drand48();
}

Random dice_random;

Vector perpendicular(const Vector &v)
{
	int max_compo = -1;
	double max_value = 0.0;
	
	for (int i = 0; i < 3; i++) {
		double t = fabs(v[i]);
		if (t > max_value) {
			max_value = t;
			max_compo = i;
		}
	}
	switch (max_compo) {
		case  0: return Vector(-(v * Vector(0,1,0))/v[0], 1, 0);
		case  1: return Vector(0, -(v * Vector(0,0,1))/v[1], 1);
		case  2: return Vector(0, 1, -(v * Vector(0,1,0))/v[2]);
		case -1:
		default:
			return Vector(0,0,0);
	}
}
